package apap.tutorial.belajarbelajar.service;

import apap.tutorial.belajarbelajar.model.CourseModel;
import apap.tutorial.belajarbelajar.model.PengajarModel;
import apap.tutorial.belajarbelajar.repository.PengajarDb;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import java.time.LocalDateTime;
import java.time.LocalTime;

import java.util.Optional;

@Service
@Transactional
public class PengajarServiceImpl implements PengajarService{
    @Autowired
    PengajarDb pengajarDb;

    @Override
    public void addPengajar(PengajarModel pengajar) {
        pengajarDb.save(pengajar);
    }

    @Override
    public PengajarModel updatePengajar(PengajarModel pengajar) {
        pengajarDb.save(pengajar);
        return pengajar;
    }

    @Override
    public PengajarModel getPengajarByNoPengajar(Long noPengajar) {
        Optional<PengajarModel> pengajar = pengajarDb.findByNoPengajar(noPengajar);
        if (pengajar.isPresent()) {
            return pengajar.get();
        } else return null;
    }

    @Override
    public boolean compareDateTime(LocalDateTime waktuBerakhir, LocalDateTime waktuDimulai) {
        boolean isEnding = true;
        LocalDateTime now = LocalDateTime.now();

        if (now.isBefore(waktuBerakhir) && now.isAfter(waktuDimulai)) {
            isEnding = false;
        }
        return isEnding;
    }

    @Override
    public boolean deletePengajar(PengajarModel pengajar, LocalDateTime waktuBerakhir, LocalDateTime waktuDimulai) {
        boolean isEnding = true;
        LocalDateTime now = LocalDateTime.now();

        if (now.isBefore(waktuBerakhir) && now.isAfter(waktuDimulai)) {
            isEnding = false;
        }
        else {
            isEnding = true;
            pengajarDb.delete(pengajar);
        }
        return isEnding;
    }
}
